# remirepo/Fedora spec file for php-zendframework-zend-stratigility
#
# Copyright (c) 2016-2020 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    840e41d1984e8845c5539c769fedc5e7bb00a4d5
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-stratigility
%global php_home     %{_datadir}/php
%global library      Stratigility
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.2.2
Release:        1%{?dist}
Summary:        Middleware for PHP

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-composer(psr/http-message)                    >= 1.0   with php-composer(psr/http-message)                    < 2)
BuildRequires: (php-autoloader(%{gh_owner}/zend-escaper)          >= 2.3   with php-autoloader(%{gh_owner}/zend-escaper)          < 3)
# remirepo:6
%else
BuildRequires:  php-composer(psr/http-message)                    <  2
BuildRequires:  php-composer(psr/http-message)                    >= 1.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-escaper)          <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-escaper)          >= 2.3
%endif
BuildRequires:  php-composer(http-interop/http-middleware)        >= 0.5
BuildRequires:  php-composer(webimpress/http-middleware-compatibility) >= 0.1.4
BuildRequires:  php-pcre
BuildRequires:  php-reflection
BuildRequires:  php-spl
# From composer, "require-dev": {
#    "malukenho/docheader": "^0.1.5",
#    "phpunit/phpunit": "^5.7.22 || ^6.4.1",
#    "zendframework/zend-coding-standard": "~1.0.0",
#    "zendframework/zend-diactoros": "^1.0"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-diactoros)        >= 1.0   with php-autoloader(%{gh_owner}/zend-diactoros)        < 2)
# remirepo:4
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-diactoros)        <  2
BuildRequires:  php-autoloader(%{gh_owner}/zend-diactoros)        >= 1.0
%endif
BuildRequires:  phpunit6                                          >= 6.4.1
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#    "php": "^5.6 || ^7.0",
#    "psr/http-message": "^1.0",
#    "webimpress/http-middleware-compatibility": "^0.1.4",
#    "zendframework/zend-escaper": "^2.3"
Requires:       php(language) >= 5.6
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-composer(psr/http-message)                    >= 1.0   with php-composer(psr/http-message)                    < 2)
Requires:      (php-autoloader(%{gh_owner}/zend-escaper)          >= 2.3   with php-autoloader(%{gh_owner}/zend-escaper)          < 3)
# remirepo:6
%else
Requires:       php-composer(psr/http-message)                    >= 1.0
Requires:       php-composer(psr/http-message)                    <  2
Requires:       php-autoloader(%{gh_owner}/zend-escaper)          >= 2.3
Requires:       php-autoloader(%{gh_owner}/zend-escaper)          <  3
%endif
Requires:       php-composer(http-interop/http-middleware)        >= 0.5
Requires:       php-composer(webimpress/http-middleware-compatibility) >= 0.1.4
# From composer, "suggest": {
#    "psr/http-message-implementation": "Please install a psr/http-message-implementation to consume Stratigility; e.g., zendframework/zend-diactoros"
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 8
Suggests:       php-autoloader(%{gh_owner}/zend-diactoros)
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.7.4
Requires:       php-pcre
Requires:       php-reflection
Requires:       php-spl

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
From "Strata", Latin for "layer", and "agility".

This package supercedes and replaces phly/conduit.

Stratigility is a port of Sencha Connect to PHP.
It allows you to create and dispatch middleware pipelines.

* File issues at https://github.com/zendframework/zend-stratigility/issues
* Issue patches to https://github.com/zendframework/zend-stratigility/pulls
* Documentation is at https://zendframework.github.io/zend-stratigility/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE

%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
require_once '%{php_home}/Interop/Http/Middleware/autoload.php';
EOF

: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Psr/Http/Message/autoload.php',
    '%{php_home}/Zend/Escaper/autoload.php',
    '%{php_home}/webimpress/http-middleware-compatibility/autoload.php',
    __DIR__ . "/functions/double-pass-middleware.php",
    __DIR__ . "/functions/middleware.php",
    __DIR__ . "/functions/path.php",
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Diactoros/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php71 php72 php73 php74; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit6 --include-path=%{buildroot}%{php_home} || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}
%{php_home}/Zend/%{library}-autoload.php


%changelog
* Tue Jan 14 2020 Remi Collet <remi@remirepo.net> - 2.2.2-1
- update to 2.2.2
- raise dependency on http-interop/http-middleware 0.5
- add dependency on webimpress/http-middleware-compatibility
- switch to phpunit6
- enable upstream test suite

* Thu Dec  6 2018 Remi Collet <remi@remirepo.net> - 1.3.3-7
- use range dependencies
- temporarily disable test suite

* Sat Dec  9 2017 Remi Collet <remi@remirepo.net> - 1.3.3-4
- switch from zend-loader to fedora/autoloader

* Tue Jan 24 2017 Remi Collet <remi@fedoraproject.org> - 1.3.3-1
- update to 1.3.3

* Fri Jan  6 2017 Remi Collet <remi@fedoraproject.org> - 1.3.2-1
- update to 1.3.2

* Fri Nov 11 2016 Remi Collet <remi@fedoraproject.org> - 1.3.1-1
- update to 1.3.1

* Thu Nov 10 2016 Remi Collet <remi@fedoraproject.org> - 1.3.0-1
- update to 1.3.0
- raise dependency on PHP 5.6
- add dependency on http-interop/http-middleware

* Sat Jul  2 2016 Remi Collet <remi@fedoraproject.org> - 1.2.1-2
- drop autoloader, rely on zend-loader >= 2.5.1-4

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 1.2.1-1
- initial package
